#ifndef _QSHEFF_MAIN_H
#define _QSHEFF_MAIN_H

#define EX_PERMANENT 31 /* Permanent rejection */
#define EX_TEMPORARY 71 /* Temporary rejection */
#define EX_WRITE 53 /* Write error */
#define EX_READ 54 /* Read error from stdin */

static int do_exit();
static int clean_exit(const char *errcode);
static char *parse_cmdline(char *line, char *path, char *exec_cmdline[10]);
static int run_ext_prog(char *cmdline[]);
static rulelist *load_rulelist();
static int load_attachlist();

enum {
  EX_OK = 0,
  EX_SPAM = 1,
  EX_VIR = 1,
  EX_ERR = 2
};

char buffer[BIGBUFSIZE];
char dir_suffix[TINYBUFSIZE];
char workdir[BIGBUFSIZE];
char tempdir[BIGBUFSIZE];

#endif
