#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wblist.h"
#include "loadconfig.h"
#include "smtp.h"
#include "defs.h"
#include "config.h"

int
read_wblist() {
	FILE *fd;
	char buffer[256];
	char *part1, *user, *domain;

	if((fd = fopen(WBLISTFILE, "r")) == NULL) {
#ifdef DEBUG
		perror("fopen WBLISTFILE");
#endif
		return -1;
	}

	while(!feof(fd)) {
		memset(sfe_ruleline, 0, sizeof(sfe_ruleline));
		fscanf(fd, "%7s", sfe_ruleline);
		if((strncmp(sfe_ruleline, "ACCEPT", sizeof(sfe_ruleline))==0) || (strncmp(sfe_ruleline, "REJECT", sizeof(sfe_ruleline))==0) || (strncmp(sfe_ruleline, "DISCARD", sizeof(sfe_ruleline))==0)) {
			fscanf(fd, "%255s", sfe_spamword);
			strncpy(buffer, sfe_spamword, sizeof(buffer)-1);
			if(strchr(sfe_spamword, '@')) { /* address */
				user = strtok(buffer, "@");
				domain = strtok(NULL, "@");

				if((user == NULL) && (domain == NULL)) continue;

				if(domain == NULL) { /* @domain.com */
					domain = user; /* user is pointing domain part */
					if((part1 = strchr(rfc821_from, '@')) != NULL)
						if(strncmp(sfe_spamword, part1, strlen(sfe_spamword)) == 0) break;
					if((part1 = strchr(rfc821_to, '@')) != NULL)
						if(strncmp(sfe_spamword, part1, strlen(sfe_spamword)) == 0) break;
				}
				else { /* user@domain.com */
					if((strncmp(sfe_spamword, rfc821_from, sizeof(sfe_spamword)) == 0) || (strncmp(sfe_spamword, rfc821_to, sizeof(sfe_spamword)) == 0)) break;
				}
			} /* ip, network */
			else
				if(strncmp(sfe_spamword, rfc821_recvfrom, strlen(sfe_spamword)) == 0) break;
		}
		else fgets(sfe_spamword, 255, fd);
	}
#ifdef DEBUG
	if(strlen(sfe_ruleline) > 0) printf("  action: %s\n", sfe_ruleline);
#endif

	return 0;
}
